#!/usr/bin/perl

# nanakochi123456 version nyatakasan/hiratara 1st release:mnakajim

BEGIN {
	require "fatlib.pl";
};

use utf8;
use strict;
use CGI;
use Encode qw/decode decode_utf8/;
use Encode::Guess;
use PlannedBlackoutJP::Util qw/is_galapagos/;
use Text::MicroTemplate::File;
use Nana::Cache;
use HTTP::Lite;
require "common.pl";
my $cache="./cache";
my $date=&date("Y-m-d");
my $date_ja=&date("Y年m月d日(lL)");

my $tohokudenryoku_base_url="http://setsuden.tohoku-epco.co.jp/common/demand/juyo_tohoku.csv";
my %tohokudenryoku_old_url;
$tohokudenryoku_old_url{2011}="http://setsuden.tohoku-epco.co.jp/common/demand/juyo_2011_tohoku.csv";
$tohokudenryoku_old_url{2010}="http://setsuden.tohoku-epco.co.jp/common/demand/juyo_2010_tohoku.csv";
$tohokudenryoku_old_url{2009}="http://setsuden.tohoku-epco.co.jp/common/demand/juyo_2009_tohoku.csv";
$tohokudenryoku_old_url{2008}="http://setsuden.tohoku-epco.co.jp/common/demand/juyo_2008_tohoku.csv";

my $cachefile="powerusage_tohoku";
my $writesokuhoufile="$cache/tohoku.twitter";

my %cachefile_old;
$cachefile_old{2011}="powerusage_tohoku_2011";
$cachefile_old{2010}="powerusage_tohoku_2010";
$cachefile_old{2009}="powerusage_tohoku_2009";
$cachefile_old{2008}="powerusage_tohoku_2008";

my %olddata;

my $debug;

my $yesterday=&date("Y/n/j",time-86400);
my %olddate;
for(my $i=2008; $i<=2010; $i++) {
	$olddate{$i}=&date("$i/n/j",time);
}

my %olddata;
my %oldpower;
my @hour_refs;

&main;

sub main {
	my $query=new CGI;
	my $mode=$query->param('m');
	my $flg=$query->param('mode');

	if($mode eq 'qr') {
		my $qr=$query->param('qr');
		my $string=$query->param('str');
		&make_qrcode($string,$qr);
		exit;
	}
	my $today=&date("n/j");
	my $target_mon=$query->param('mon');
	my $target_day=$query->param('day');
	if($target_mon eq '' || $target_day eq '') {
		$target_mon=&date("n");
		$target_day=&date("j");
	}

	my $mobileflg=0;
	my $mflg=0;
	$mflg=1 if($mode=~/m/);
	my $englishflg=0;
	$englishflg=1 if($mode=~/e/);
	$mobileflg=1 if(is_galapagos(\%ENV) || $mflg);

	if($mobileflg eq 0) {
		for(my $i=2008; $i<=2011; $i++) {
			$olddata{$i}=&get($cachefile_old{$i},$tohokudenryoku_old_url{$i},"update");
		}
	} else {
		$olddata{2011}=&get($cachefile_old{2011},$tohokudenryoku_old_url{2011},"update");
	}

	my($update_date,$update_time,$tmp);
	my $update_str;
	my($kyoukyuu_kw,$kyoukyuu_time,$kyoukyuu_date,$kyoukyuu_update_time);
	my($maxpower_kw,$maxpower_time,$maxpower_date,$maxpower_update_time);
	my $today_persent;
	my $maxupdate;
	my $last_today_power;
	my $last_today_time;
	my $last_today_persent;


	if($today eq "$target_mon\/$target_day") {
		my $http_body=&get($cachefile,$tohokudenryoku_base_url,$flg);

		my @pwtmp=split(/\n/,$http_body);
		my $update=$pwtmp[0];
		my $kyoukyuu=$pwtmp[2];
		my $maxpower=$pwtmp[5];
		my @pw;
		for(my $i=0; $i<24; $i++) {
			$pw[$i]=$pwtmp[$i+8];
		}
			
		($update_date,$update_time,$tmp)=split(/ /,$update);
		$update_str="$update_date $update_time";
		($kyoukyuu_kw,$kyoukyuu_time,$kyoukyuu_date,$kyoukyuu_update_time)
			=split(/,/,$kyoukyuu);
		($maxpower_kw,$maxpower_time,$maxpower_date,$maxpower_update_time)
			=split(/,/,$maxpower);
		$today_persent=int(($maxpower_kw+0) / ($kyoukyuu_kw+0)*100);
		$maxupdate="$maxpower_date $maxpower_update_time";

		for(my $i=0; $i<24; $i++) {
			my($pw_date,$pw_time,$today_power,$forecast_power)
				=split(/,/,$pw[$i]);
			if($today_power+0 ne 0) {
				$last_today_power=$today_power;
				$last_today_time=$pw_time;
				$last_today_persent=int(($today_power+0) / ($kyoukyuu_kw+0)*100);
			}
			my $persent=int(($today_power+0) / ($kyoukyuu_kw+0)*100);
			my $yesterday_power=&getpower($yesterday,$i,$olddata{2011},0);
			if($flg eq "oldview" && $mobileflg eq 0) {
				for(my $j=2008; $j<=2010; $j++) {
					$oldpower{$j}=&getpower($olddate{$j},$i,$olddata{$j},0);
				}
			}
			my $diff=$today_power eq 0 && $yesterday_power eq 0 ? 0 : $today_power - $yesterday_power;
			push @hour_refs,  {
				date => $pw_date,
				time => $pw_time,
				today_power => $today_power,
				forecast_power => $forecast_power,
				yesterday_power => $yesterday_power,
				persent => $persent,
				diff => $diff,
				power2010 => $oldpower{2010},
				power2009 => $oldpower{2009},
				power2008 => $oldpower{2008},
			};
		}
	} else {
		for(my $i=2008; $i<=2011; $i++) {
			$olddate{$i}="$i/$target_mon/$target_day";
		}
		for(my $i=0; $i<24; $i++) {
			my %pw_date;
			my %pw_time;
			for(my $j=2008; $j<=2011; $j++) {
				($pw_date{$j},$pw_time{$j},$oldpower{$j})
					=&getpower($olddate{$j},$i,$olddata{$j},1);
			}
			push @hour_refs,  {
				date => $pw_date{2011} ne ''
					 ? $pw_date{2011}
					 : $pw_date{2010} ne '' ? $pw_date{2010} : $pw_date{2008},
				time => $pw_time{2011} ne ''
					 ? $pw_time{2011}
					 : $pw_time{2010} ne '' ? $pw_time{2010} : $pw_date{2008},
				today_power => $oldpower{2011},
				forecast_power => 0,
				yesterday_power => 0,
				persent => 0,
				diff => '',
				power2010 => $oldpower{2010},
				power2009 => $oldpower{2009},
				power2008 => $oldpower{2008},
			};
		}
	}

	if($today eq "$target_mon\/$target_day") {
		if(open(W,">$writesokuhoufile")) {
			my($tmp_hour,$tmp_time)=split(/:/,$last_today_time);
			my $pw_time_hour=$tmp_hour;
			my $pw_time_time=$tmp_time;
			my $pw_time_ja=sprintf("%d時%02d分",$tmp_hour,$tmp_time);

			my $twitter="@{[$date]}-$pw_time_hour-$pw_time_time" . ',';
			$twitter.=<<EOM if($pw_time_hour >= 8 && $pw_time_hour <= 21);
	@{[$date_ja ]} @{[$pw_time_ja]} @{[$last_today_power]}万kW / @{[$kyoukyuu_kw]}万kW (@{[$last_today_persent]}％) #jishin_power
EOM
			if($last_today_persent >= 99) {
				$twitter.=" 計画停電の可能性があります。#keikakuteiden";
			}
			print W $twitter;
			close(W);
		}
	}
	&gzip_compress("Content-type: text/html; charset=utf-8\nCache-Control: max-age=0\nExpires: Mon, 26, Jul 1997 05:00:00 GMT");
	my $mtf = Text::MicroTemplate::File->new;
	my $template;
	if($mflg eq 1) {
		if($englishflg eq 1) {
			$template="powerusage_en_m.html";
		} else {
			$template="powerusage_jp_m.html";
		}
	} else {
		if($englishflg eq 1) {
			$template="powerusage_en.html";
		} else {
			$template="powerusage_jp.html";
		}
	}
	my($basehref, $basehost, $basepath)=&getbasehref;
	my $qrmode= $englishflg ? "me" : "mj";
	my $html = $mtf->render_file(
		$template,
		"東北電力","Tohoku",
		"$update_date $update_time",
		$kyoukyuu_kw,$kyoukyuu_time,
		$maxpower_kw,$maxpower_time,
		$today_persent,$maxupdate,
		\@hour_refs,
		&make_link_qrcode("$basehref?m=$qrmode"),
		$flg eq "oldview" ? 1 : 0,
		$target_mon, $target_day,
);

	if($mobileflg) {
		$html=&z2h($html);
	}

	print <<EOM;
<?xml version="1.0" encoding="UTF-8" ?>
$html$debug
EOM
}

sub getpower {
	my($date,$hour,$data,$flg)=@_;
	my $gettime="$hour:00";
	foreach (split(/\n/,$data)) {
		my($d,$t,$p)=split(/,/,$_);
		if($date eq $d && $gettime eq $t) {
			if($flg eq 1) {
				return($d,$t,$p);
			} else {
				return $p;
			}
		}
	}
	if($flg eq 1) {
		return('','','');
	} else {
		return '';
	}
}

sub get {
	my($cachefile,$url,$mode)=@_;

	my $cache=new Nana::Cache (
		ext=>"csv",
		files=>100,
		dir=>"./cache",
		size=>100000,
		use=>1,
		expire=>60*60,
	);

	my $http_body=$cache->read($cachefile,0);
	if($http_body eq '' || 	$mode eq  'update') {
		my $status;
		($status,$http_body)=&httpcl($url);
		if($status eq 0) {
			$cache->write($cachefile,$http_body);
		}
	}

	$http_body=~s/\x0D\x0A|\x0D|\x0A/\x0A/g;
	$http_body=&force_decode($http_body);
	return $http_body;
}

sub httpcl {
	my ($url)=shift;
	my $http=new HTTP::Lite;
	$http->method("GET");
	$http->http11_mode(1);
	my $req=$http->request($url);
	if($req eq 200) {
		return(0,$http->body());
	} else {
		return(1,"Error $req");
	}
}

# QRコードの画像のリンクを作成
sub make_link_qrcode {
	my ($string) = shift;
	if(&load_module("GD") && &load_module("GD::Barcode")) {
		my($basehref, $basehost, $basepath)=&getbasehref;
		$string=&enc($string);
		return "$basehref?m=qr\&amp;str=$string";
	}
	'';
}
